#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mcheck.h>
#include "lcshash.h"
#define MAXPATH 128
#define MAXINTEGER 20
#define HASHSIZE 5
int main(void)
{
    char record[MAXL+MAXINTEGER+2]; 
    char key[MAXL + 1];  
    int value;              
    char fn[MAXPATH+1];  
    hashTable_t * ht;     
    hashElement_t * he;    
    int i;             
    
    int h1;          
    FILE *archivio;        
    
    mtrace();
    
    sprintf(fn,"./.lcshash.dat");
    archivio=fopen(fn,"r");
    if ( archivio == NULL ) {
	perror(fn);
	return 1;
    }
    
    
    
    if ( ( ht = createHash (0))  != NULL ) printf("Fail: createHash vuoto!\n");
    else printf("OK: createHash vuoto!\n");
    
    deleteHash(ht);
    if ( ( ht = createHash(HASHSIZE)) == NULL ) printf("Fail: createHash non vuoto!\n");  
    else printf("OK: createHash non vuoto!\n");
    
    deleteHash(ht);
    if ( ( ht = createHash(HASHSIZE)) == NULL ) printf("Fail: createHash non vuoto!\n");  
    else printf("OK: createHash non vuoto!\n");
       
    printf("hashFunction: test HT vuota = %d\n",hashFunction("pippo",NULL));
    
    i= 0;
    while ( record == fgets (record,MAXL + MAXINTEGER + 2,archivio) ) {
	if ( sscanf(record,"%s%d", key, &value) != 2 ) {
	    fprintf (stderr,"Formato errato a linea %d!\n",i+1);
	    deleteHash(ht);
	    return 1;
	}
	
	
	fprintf (stdout,"Test %d: %s %d\n",i+1,key,value);
	
	fprintf(stderr,"hashFunction: %s = %d\n",key,h1=hashFunction(key,ht));
        
	if ( putHash(ht,key, value) == NULL ) printf("putHash: #%d: failed \n",i+1);
	else printf("putHash: #%d:OK \n",i+1);
	i++;
    }
    fclose(archivio);
    printf("%d test letti\n\n",i);
    
    sprintf(fn,"./.lcshash2.dat");
    archivio=fopen(fn,"r");
    if ( archivio == NULL ) {
	perror(fn);
	deleteHash(ht);
	return 1;
    }
    
    i=0;
    while ( record == fgets (record,MAXL + MAXINTEGER + 2,archivio) ) {
	if ( sscanf(record,"%s", key) != 1) {
	    fprintf (stderr,"Formato errato a linea %d!\n",i+1);
	    deleteHash(ht);
	    return 1;
	}
	
	
	fprintf (stdout,"Test %d: %s \n",i+1,key);
	
	fprintf(stderr,"hashFunction: %s = %d\n",key,h1=hashFunction(key,ht));
        
	if ( ( he =getHash(ht,key)) == NULL ) 
	    printf("getHash: #%d: failed \n",i+1);
	else {
	    printf("getHash: #%d:OK \n",i+1);
	    printHashElement(stdout,he);
	    putchar('\n');
	}
	
	if ( ( he = removeFromHash(ht,key)) == NULL) printf("removeHash: #%d: failed \n",i+1);
	else  {
	    printf("removeHash: #%d: OK \n",i+1);
	    deleteHashElement(he);
	}
	i++; 
    }
    fclose(archivio);
    
    
    if ( putHash(ht,"pippo", 456) == NULL ) printf("putHash: 1: failed \n");
    else printf("putHash: 1:OK \n");
    if ( putHash(ht,"pippo", 456) == NULL ) printf("putHash: 2: double value OK \n");
    else printf("putHash: 2: double value failed 1\n");
   
    
    he = removeFromHash(ht,"pippo");
    printf("remove::");
    printHashElement(stdout,he);
    deleteHashElement(he);
    putchar('\n');
    
    he = removeFromHash(ht,"pippo");
    printf("remove::");
    printHashElement(stdout,he);
    deleteHashElement(he);
    putchar('\n');
    
    deleteHash(ht);
    printf("Test Finished!\n");
    return 0;
}
